package Org::Ruka::CommandAppend;

use warnings;
use strict;

use base qw/Net::IMAP::Server::Command::Append/;

use Coro;

# similar to SUPER, but pass the options through
# and APPENDUID is optional
sub run {
    my $self = shift;

    my @options = $self->parsed_options;

    my $mailbox = $self->connection->model->lookup( shift @options );
    my $msg = $mailbox->append(@options);
    if ($msg) {
        if (ref($msg)) { 
            $self->ok_command("[APPENDUID @{[$mailbox->uidvalidity]} @{[$msg->uid]}] APPEND COMPLETED");
        } else {
            $self->ok_command("APPEND COMPLETED");
        }
    } else {
        $self->no_command("Permission denied");
    } 
}

1;
