package Org::Ruka::CommandCopy;

use warnings;
use strict;

use base qw/Net::IMAP::Server::Command::Copy/;

use Coro;

# same as SUPER, except COPYUID is optional
sub run {
    warn "in Org::Ruka::CommandCopy";
    my $self = shift;
    my ( $messages, $name ) = $self->parsed_options;
    my @messages = $self->connection->get_messages($messages);

    my $mailbox = $self->connection->model->lookup( $name );

    return $self->no_command("Permission denied") if grep {not $_->copy_allowed($mailbox)} @messages;

    my $uidvalidity = $mailbox->uidvalidity;;
    my @new;
    for my $m (@messages) {
        my $mprime = $m->copy($mailbox);
        if (defined($mprime)) {
            push @new, $mprime;
        } else {
            $uidvalidity = 'invalid';
        }
        cede;
    }
    my $sequence = join(",",map {$_->uid} @messages);
    my $uids     = join(",",map {$_->uid} @new);
    if ($uidvalidity eq $mailbox->uidvalidity) {
        $self->ok_command("[COPYUID $uidvalidity $sequence $uids] COPY COMPLETED");
    } else {
        $self->ok_command("COPY COMPLETED");
    }
}

1;
