package Org::Ruka::ProxyAuth;
use strict;
use warnings;
use base qw 'Net::IMAP::Server::DefaultAuth';
use Org::Ruka::IMAPClient;
use Org::Ruka::IMAPPool;
use Data::Dumper;
use Org::Ruka::HandleSocket;
      
Org::Ruka::ProxyAuth->mk_accessors('imappool', 'password');


our $server = 'imap.example.org';
our $port = 'imaps';
our $ssl = 1;
sub auth_plain {
    my ($self, $user, $pass) = @_;
    my @args = (connect => [ $server, $port ]);
    if ($ssl) {
        push @args, tls => 'connect';
    }
    
    $self->user($user);
    $self->password($pass);
    
    my @otherpass;
    foreach (Net::IMAP::Server->concurrent_user_connections($user)) {
        if ($_->auth->password ne $pass) {
            push @otherpass, $_;
        } elsif ($_->auth->imappool) {
            warn "reusing pool";
            $self->imappool($_->auth->imappool);
            last;
        }
    }
    if (!$self->imappool) {
        warn "new pool";
        $self->imappool(Org::Ruka::IMAPPool->new({connection => \@args, user => $user, password => $pass}));
    }

    if ($self->imappool) {
        print "Logged in as $user\n";
        foreach (@otherpass) {
            warn "Closing connection with outdated password";
            $_->close();
        }
        return 1;
    }
    return 0;
}

1;
